﻿using System;
using System.Threading;

namespace ConsoleApplication1
{
    class ThreadParam
    {
        public int Value1;
        public int Value2;
    }

    class Program
    {
        static void Main(string[] args)
        {
            ThreadParam param = new ThreadParam();
            param.Value1 = 10;
            param.Value2 = 20;

            Thread t = new Thread(threadFunc);
            t.IsBackground = true;
            t.Start(param);

            t.Join(); // t 스레드가 종료할 때 까지 현재 스레드를 무한 대기
            Console.WriteLine("주 스레드 종료!");
        }

        static void threadFunc(object initialValue)
        {
            ThreadParam value = (ThreadParam)initialValue;

            Console.WriteLine("60초 후에 프로그램 종료");
            Thread.Sleep(1000 * 60); // 60초 동안 실행 중지

            Console.WriteLine("{0}, {1}", value.Value1, value.Value2); // 출력 결과: 10, 20
            Console.WriteLine("스레드 종료!");
        }

    }
}
